<template>
  <div>
    <div
      v-for="(question, indexQuestions) in questionsList"
      :key="indexQuestions"
      style="padding: 5px;"
    >
      <v-card
        class="mx-auto"
        outlined
      >
        <v-container fill-height fluid>
          <v-row>
            <v-col>
              <div v-if="question.form_type !== 'DEFAULT'">
                <fill-out-question :question="question" />
              </div>
            </v-col>
            <v-col xl="4" sm="4" xs="4">
              <v-select
                v-model="question.form_type"
                :items="questionTypes"
                :label="$t('label.select_type_questions')"
                item-value="value"
                item-text="label"
                @change="questionTypeChanged(indexQuestions)"
              />
            </v-col>
          </v-row>
          <v-row>
            <v-col>
              <div v-if="question.form_type === 'CHECKBOX'">
                <div
                  v-for="(option, indexOptions) in question.options"
                  :key="indexOptions"
                  class=""
                >
                  <type-questions-check-box
                    :option="option"
                    :index-questions="indexQuestions"
                    :index-options="indexOptions"
                    :length-index="question.options.length - 1"
                    :delete-option-item="deleteQuestionOptionItem"
                    :add-option-item="addAnotherAnswer"
                  />
                </div>
              </div>
              <div v-if="question.form_type === 'MULTI_CHOICE'">
                <div
                  v-for="(option, indexOptions) in question.options"
                  :key="indexOptions"
                  class=""
                >
                  <type-questions-radio-button
                    :option="option"
                    :index-questions="indexQuestions"
                    :index-options="indexOptions"
                    :length-index="question.options.length - 1"
                    :delete-option-item="deleteQuestionOptionItem"
                    :add-option-item="addAnotherAnswer"
                  />
                </div>
              </div>
              <div v-if="question.form_type === 'ADDRESS'">
                <type-questions-address :disabled-address="true" />
              </div>
            </v-col>
          </v-row>
          <v-row>
            <div v-if="indexQuestions !== 0" class="buttons-section">
              <v-btn
                color="error"
                class="button-qa-builder-delete"
                absolute
                bottom
                outlined
                right
                @click="deleteQuestion(indexQuestions)"
              >
                {{ $t('label.delete') }}
              </v-btn>
            </div>
            <div class="buttons-required">
              <v-switch
                v-model="question.require"
                class="question-builder-switch"
                inset
              >
                <template #prepend>
                  <v-label style="min-width: 5rem !important;">{{ $t('label.must_be_filled') }}</v-label>
                </template>
              </v-switch>
            </div>
          </v-row>
        </v-container>
      </v-card>
    </div>
  </div>
</template>

<script>
import { ValidationProvider } from 'vee-validate'

export default {
  name: 'SurveyQuestionsBuilder',
  components: {
    ValidationProvider
  },
  props: {
    questionsList: {
      type: Array,
      default: null
    }
  },
  data() {
    return {
      questionTypes: [
        { value: 'SHORTTEXT', label: this.$t('label.short_answer') },
        { value: 'MULTI_CHOICE', label: this.$t('label.multiple_choice') },
        { value: 'CHECKBOX', label: this.$t('label.checkbox') },
        { value: 'ADDRESS', label: this.$t('label.address') }
      ],
      selectedType: null
    }
  },
  methods: {
    questionTypeChanged(indexQuestions) {
      switch (this.questionsList[indexQuestions].form_type) {
        case 'SHORTTEXT':
          this.questionsList[indexQuestions]
          break
        case 'CHECKBOX':
          this.questionsList[indexQuestions]
          break
        case 'MULTI_CHOICE':
          this.questionsList[indexQuestions]
          break
        case 'ADDRESS':
          this.questionsList[indexQuestions]
          break
        default:
          //
      }
    },
    addAnotherAnswer(indexQuestions) {
      if (!this.questionsList[indexQuestions].options) {
        this.questionsList[indexQuestions].options = []
      }
      let maxSequence = Number(Math.max(this.questionsList[indexQuestions].options.map(x => x.sequence)))
      if (!maxSequence) {
        maxSequence = this.questionsList[indexQuestions].options.length
      }
      this.questionsList[indexQuestions].options.push({ sequence: maxSequence + 1 })
    },
    deleteQuestionOptionItem(indexQuestions, indexOptions) {
      this.questionsList[indexQuestions].options.splice(indexOptions, 1)
    },
    deleteQuestion(indexQuestions) {
      this.$store.dispatch('survey/deleteQuestionSurvey', indexQuestions)
    }
  }
}
</script>
<style scoped>
  .buttons-section {
    padding-top: 50px;
  }
  .buttons-required {
    padding-left: 50px;
  }
  .button-qa-builder-delete {
    height: 2.5rem !important;
    min-width: 1rem !important;
  }
</style>
